poj 1734 Sightseeing trip判断最短长度的环
Time Limit: 1000MS | Memory Limit: 65536K | |||
Total Submissions: 5590 | Accepted: 2151 | Special Judge |
Description
In the town there are N crossing points numbered from 1 to N and M
two-way roads numbered from 1 to M. Two crossing points can be
connected by multiple roads, but no road connects a crossing point with
itself. Each sightseeing route is a sequence of road numbers y_1, ...,
y_k, k>2. The road y_i (1<=i<=k-1) connects crossing points x_i
and x_{i+1}, the road y_k connects crossing points x_k and x_1. All the
numbers x_1,...,x_k should be different.The length of the sightseeing
route is the sum of the lengths of all roads on the sightseeing route,
i.e. L(y_1)+L(y_2)+...+L(y_k) where L(y_i) is the length of the road y_i
(1<=i<=k). Your program has to find such a sightseeing route,
the length of which is minimal, or to specify that it is not
possible,because there is no sightseeing route in the town.
Input
first line of input contains two positive integers: the number of
crossing points N<=100 and the number of roads M<=10000. Each of
the next M lines describes one road. It contains 3 positive integers:
the number of its first crossing point, the number of the second one,
and the length of the road (a positive integer less than 500).
Output
is only one line in output. It contains either a string 'No solution.'
in case there isn't any sightseeing route, or it contains the numbers of
all crossing points on the shortest sightseeing route in the order how
to pass them (i.e. the numbers x_1 to x_k from our definition of a
sightseeing route), separated by single spaces. If there are multiple
sightseeing routes of the minimal length, you can output any one of
them.
Sample Input
5 7
1 4 1
1 3 300
3 1 10
1 2 16
2 3 100
2 5 15
5 3 20
Sample Output
1 3 5 2
Source
[Submit] [Go Back] [Status] [Discuss]
网上的题解都是用floyd做出来的,用floyd最短路算法判断是否有环,但是我感觉dfs足可以解决这道题
下面的是我的代码和题解,后面我还会贴上网上大牛用floyd写的算法
dfs:以边为核心,边上的两个点一个为起点,一个为终点,开始进行dfs搜索。每次从起点出发,如果找到终点并且路程变小就记录下路径,在后输出最短路的路径即可
如过ans的值和起始值一样的话,就相当于没有环出现,那么输出那个字符串就可以了
#include<stdio.h>
#include<string.h>
#include<iostream>
#include<algorithm>
using namespace std;
const int inf=;
int n,m;
int Map[][];
int head[];
int temp;
bool vis[];
int a[];
int start ,end;
int ans;
bool judge;
int t;
int cnt;
int ans_num;
void dfs(int u,int node,int dis){ if(u==end){
if(dis<ans){
ans=dis; for(int i=;i<node;i++)
a[i]=head[i];
a[node]=u;
ans_num=node;
}
return ;
}
head[node]=u;
for(int i=;i<=n;i++){
if(!Map[u][i]||vis[i])
continue;
vis[i]=true;
if(dis+Map[u][i]<ans)
dfs(i,node+,dis+Map[u][i]);
vis[i]=false;
}
return;
}
int main(){
while(scanf("%d",&n)!=EOF){
if(n==-)
break;
memset(Map,,sizeof(Map));
scanf("%d",&m);
int u,v,w;
for(int i=;i<m;i++){
scanf("%d%d%d",&u,&v,&w); if(!Map[u][v]){
Map[u][v]=w;
Map[v][u]=w;
}
else{
if(w<Map[u][v]){
Map[u][v]=w;
Map[v][u]=w;
}
}
}
ans=inf;
for(int i=;i<=n;i++)
for(int j=i+;j<=n;j++){
if(Map[i][j]==)
continue;
memset(vis,false,sizeof(vis));
t=Map[i][j];
Map[i][j]=;
Map[j][i]=;
start=i;
end=j;
vis[i]=true;
dfs(start,,t); Map[i][j]=t;
Map[j][i]=t;
}
if(ans!=inf){ for(int i=;i<=ans_num;i++)
printf("%d%c",a[i],i==ans_num?'\n':' ');
} else printf("No solution.\n");
}
return ;
}
floyd算法代码
给出一张无向图,求一个最小环并输出路径。
说说我的感觉:
包含点 i 和点 j 的最小环,我们可以看成是 i 到 j 之间的最短路和次短路的组合,通过 floyd 可求任意两点之间的最短距离,那么我们只要找到最短路径外的一条最短路来保证 i 和 j 之间可达即可。在做 floyd 循环的同时,我们以 环权值 最小(最短路权值+次短路权值=最小环权值)为标准,一直更新每个点的前驱,也就是记录 i 到 j 的最短路径,以及,能够松弛 i 和 j 的点 k (k 不在 i 到 j 的最短路径中)中代价最小的那个(也就是 i 到 j 之间的次短路),然后按环的自然顺序输出即可。
代码中也注释的很详细了:
#include<cstdio>
#include<cstring>
#define find_min(a,b) a<b?a:b const int N = ;
const int INF = 0x7ffffff;
int mat[N][N],dist[N][N],pre[N][N],path[N],n; int main()
{
int i,j,k,m,a,b,c;
int num; while(~scanf("%d%d",&n,&m)){
for(i=;i<=n;i++){
for(j=;j<=n;j++){
mat[i][j]=dist[i][j]=INF;
pre[i][j]=i;
}
}
while(m--){
scanf("%d%d%d",&a,&b,&c);
mat[a][b]=mat[b][a]=dist[a][b]=dist[b][a]=find_min(mat[a][b],c);
} int min=INF;
for(k=;k<=n;k++){//最短路径外一点将最短路首尾链接,那么就得到一个最小环
for(i=;i<k;i++){
for(j=i+;j<k;j++){
//求最小环不能用两点间最短路松弛,因为(i,k)之间的最短路,(k,j)之间的最短路可能有重合的部分
//所以mat[][]其实是不更新的,这里和单纯的floyd最短路不一样
//dist[i][j]保存的是 i 到 j 的最短路权值和
int tmp=dist[i][j]+mat[i][k]+mat[k][j];//这里 k 分别和 i 还有 j 在mat中直接相连
if(tmp<min){
min=tmp;
num=;
int p=j;
while(p!=i){//回溯
path[num++]=p;
p=pre[i][p];//pre[i][j]表示 i 到 j 最短路径上 j 前面的一个点
}
path[num++]=i;
path[num++]=k;
}
}
}
for(i=;i<=n;i++){
for(j=;j<=n;j++){
if(dist[i][j]>dist[i][k]+dist[k][j]){
dist[i][j]=dist[i][k]+dist[k][j];//dist[][]保存两点间最短距离
pre[i][j]=pre[k][j];
}
}
}
}
if(min==INF)puts("No solution.");
else{
printf("%d",path[]);
for(i=;i<num;i++)
printf(" %d",path[i]);
puts("");
}
}
return ;
}
poj 1734 Sightseeing trip判断最短长度的环的更多相关文章
- POJ 1734 Sightseeing trip(Floyd)
题目传送门 题目中文翻译: Description 桑给巴尔岛上的阿德尔顿镇有一家旅行社,它已决定为其客户提供除了许多其他名胜之外的景点.为了尽可能地从景点赚取收入,该机构已经接受了一个精明的决定:有 ...
- POJ 1734 Sightseeing trip(无向图最小环+输出路径)
题目链接 #include <cstdio> #include <string> #include <cstring> #include <queue> ...
- POJ 1734.Sightseeing trip (Floyd 最小环)
Floyd 最小环模板题 code /* floyd最小环,记录路径,时间复杂度O(n^3) 不能处理负环 */ #include <iostream> #include <cstr ...
- POJ 1734 Sightseeing trip
题目大意: 求一个最小环. 用Floyd 求最小环算法. #include <iostream> #include <cstdlib> #include <cstdio& ...
- poj 1734 Sightseeing trip_ 最小环记录路径
题意:求最出小环,输出路径 #include <iostream> #include<cstdio> using namespace std; #define N 110 #d ...
- POJ 3621 Sightseeing Cows(最优比例环+SPFA检测)
Sightseeing Cows Time Limit: 1000MS Memory Limit: 65536K Total Submissions: 10306 Accepted: 3519 ...
- POJ 3621 Sightseeing Cows (最优比率环 01分数划分)
题意: 给定L个点, P条边的有向图, 每个点有一个价值, 但只在第一经过获得, 每条边有一个花费, 每次经过都要付出这个花费, 在图中找出一个环, 使得价值之和/花费之和 最大 分析: 这道题其实并 ...
- POJ 1734:Sightseeing trip
Sightseeing trip Time Limit: 1000MS Memory Limit: 65536K Total Submissions: Accepted: Special Judge ...
- Sightseeing trip POJ - 1734 -Floyd 最小环
POJ - 1734 思路 : Floyd 实质 dp ,优化掉了第三维. dp [ i ] [ j ] [ k ] 指的是前k个点优化后 i -> j 的最短路. 所以我们就可以 ...
随机推荐
- CF Gym 100637F The Pool for Lucky Ones
题意:给你一串非负整数,可以将一个非零数减1,加到相邻的数字上,要使其中所有最大数字的和最小. 题解:模拟可以过.也可以分析,可以要减少最大数字和,如果最大数字出现大于等于3次,可以把最大数字加一,或 ...
- CF Gym 100637G \#TheDress (水)
题解:读懂题意按照题意模拟... 熟悉了一个库函数,strstr,memcpy #include<cstdio> #include<cstring> int main() { ...
- 用 label 控制 Pod 的位置
默认配置下,Scheduler 会将 Pod 调度到所有可用的 Node.不过有些情况我们希望将 Pod 部署到指定的 Node,比如将有大量磁盘 I/O 的 Pod 部署到配置了 SSD 的 Nod ...
- 抓取oracle建表语句及获取建表ddl语句
抓取oracle建表语句及获取建表ddl语句 1.抓取代码如下: 1.1.产生表的语法资料 DECLARE-- v_notPartTable VARCHAR2(1000):= '&2'; -- ...
- Visual Studio 2017 UTF-8 无 BOM 一站式解决办法
问题背景:最近捡起C++,使用VS 2017平台.因为以前的编程习惯,喜欢使用UTF-8 无 BOM 的编码格式,好让自己的代码全球通用.但是VS 2017 对这个问题不是很友善.但最终找到了解决办法 ...
- 03大端和小端(Big endian and Little endian)
1.大端和小端的问题 对于整型.长整型等数据类型,Big endian 认为第一个字节是最高位字节(按照从低地址到高地址的顺序存放数据的高位字节到低位字节),而 Little endian 则相反 ...
- LeetCode之Weekly Contest 102
第一题:905. 按奇偶校验排序数组 问题: 给定一个非负整数数组 A,返回一个由 A 的所有偶数元素组成的数组,后面跟 A 的所有奇数元素. 你可以返回满足此条件的任何数组作为答案. 示例: 输入: ...
- spartan6不能直接把时钟连到IO上
1.问题的提出:spartan6中不允许时钟信号直接连到IO口上面? 2.解决办法: ODDR2的使用 ODDR2Primitive: Double Data Rate Output D Flip-F ...
- python并发编程之线程剩余内容(线程队列,线程池)及协程
1. 线程的其他方法 import threading import time from threading import Thread,current_thread def f1(n): time. ...
- Java-basic-6-方法
命令行参数的使用 public class test { public static void main(String args[]) { for(int i = 0; i < args.len ...